'use strict';

exports.__esModule = true;

var _alt$lazy$match$seq$str = require('parsly/parser');

var _lex = require('./util');

var number = _alt$lazy$match$seq$str.match(/-?(?:0|[1-9]\d*)(?:\.\d+)?(?:[eE][+-]?\d+)?/);
var string = _alt$lazy$match$seq$str.seq(_alt$lazy$match$seq$str.str('"'), _alt$lazy$match$seq$str.match(/[^"]+/), _alt$lazy$match$seq$str.str('"'));
var array = _alt$lazy$match$seq$str.lazy(function () {
  return _alt$lazy$match$seq$str.seq(_alt$lazy$match$seq$str.str('['), _alt$lazy$match$seq$str.alt(array, _alt$lazy$match$seq$str.match(/[^\[\]]+/)).many(), _alt$lazy$match$seq$str.str(']'));
});
var object = _alt$lazy$match$seq$str.lazy(function () {
  return _alt$lazy$match$seq$str.seq(_alt$lazy$match$seq$str.str('{'), _alt$lazy$match$seq$str.alt(object, _alt$lazy$match$seq$str.match(/[^\{\}]+/)).many(), _alt$lazy$match$seq$str.str('}'));
});
var keywords = _alt$lazy$match$seq$str.alt(_alt$lazy$match$seq$str.str('null'), _alt$lazy$match$seq$str.str('true'), _alt$lazy$match$seq$str.str('false'));
var value = _lex.lex(_alt$lazy$match$seq$str.alt(keywords, number, string, array, object));

exports['default'] = value;
module.exports = exports['default'];