'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } };

exports.__esModule = true;

var _each = require('lodash/collection/each');

var _each2 = _interopRequireWildcard(_each);

var _assign = require('lodash/object/assign');

var _assign2 = _interopRequireWildcard(_assign);

var _identity = require('lodash/utility/identity');

var _identity2 = _interopRequireWildcard(_identity);

var _traverse = require('../traverse');

var _traverse2 = _interopRequireWildcard(_traverse);

function normalize(transformer) {
  transformer = _assign2['default']({}, transformer);

  if (!transformer.enter) transformer.enter = _identity2['default'];
  if (!transformer.exit) transformer.exit = _identity2['default'];

  _each2['default'](transformer, function (opts, type) {
    if (type[0] === '_') return;

    if (!opts.enter) opts.enter = _identity2['default'];
    if (!opts.exit) opts.exit = _identity2['default'];
  });

  return transformer;
}

var Transformer = (function () {
  function Transformer(transformer) {
    _classCallCheck(this, Transformer);

    this.handlers = normalize(transformer);
  }

  Transformer.prototype.run = function run(ast, state) {
    return _traverse2['default'](ast, this.handlers, state);
  };

  return Transformer;
})();

exports['default'] = Transformer;
module.exports = exports['default'];