'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

exports.__esModule = true;

var _import = require('graphql-types');

var GraphQL = _interopRequireWildcard(_import);

var Query = {
  exit: function exit(node) {
    return new GraphQL.Query(node.name, node.arguments, node.fields, node.fragments);
  } };

exports.Query = Query;
var Fragment = {
  exit: function exit(node) {
    return new GraphQL.Fragment(node.name, node.fields, node.fragments);
  } };

exports.Fragment = Fragment;
var Field = {
  exit: function exit(node) {
    return new GraphQL.Field(node.name, node.fields, node.fragments, node.calls);
  } };

exports.Field = Field;
var Call = {
  exit: function exit(node) {
    return new GraphQL.Call(node.callee, node.arguments);
  } };

exports.Call = Call;
var Identifier = {
  enter: function enter(node, state) {
    return state.variables[node.name];
  } };

exports.Identifier = Identifier;
var Reference = {
  enter: function enter(node, state) {
    return state.arguments[node.index];
  } };

exports.Reference = Reference;
var Literal = {
  enter: function enter(node) {
    return node.value;
  } };
exports.Literal = Literal;