'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

exports.__esModule = true;
exports['default'] = traverse;

var _isPlainObject = require('lodash/lang/isPlainObject');

var _isPlainObject2 = _interopRequireWildcard(_isPlainObject);

var _import = require('./types');

var t = _interopRequireWildcard(_import);

function traverse(node, opts, state) {
  if (Array.isArray(node)) {
    return node.map(function (child) {
      return traverse.node(child, opts, state);
    });
  }

  if (!_isPlainObject2['default'](node)) {
    return node;
  }

  return traverse.node(node, opts, state);
}

traverse.node = function (node, opts, state) {
  var keys = t.VISITOR_KEYS[node.type];
  if (!keys) return node;

  var replacement = call('enter', node, opts, state);
  if (replacement !== node) return replacement;

  for (var i = 0; i < keys.length; i++) {
    node[keys[i]] = traverse(node[keys[i]], opts, state);
  }

  replacement = call('exit', node, opts, state);
  if (replacement !== node) return replacement;

  return node;
};

function call(event, node, opts, state) {
  opts = opts[node.type] || opts;

  var visitor = opts[event];
  var replacement = visitor(node, state);

  return replacement;
}
module.exports = exports['default'];