'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

exports.__esModule = true;
exports.is = is;

var _each = require('lodash/collection/each');

var _each2 = _interopRequireWildcard(_each);

var _BUILDER_KEYS = require('./builder_keys');

var _BUILDER_KEYS2 = _interopRequireWildcard(_BUILDER_KEYS);

var _VISITOR_KEYS = require('./visitor_keys');

var _VISITOR_KEYS2 = _interopRequireWildcard(_VISITOR_KEYS);

exports.BUILDER_KEYS = _BUILDER_KEYS2['default'];
exports.VISITOR_KEYS = _VISITOR_KEYS2['default'];

function lcfirst(string) {
  return string[0].toLowerCase() + string.slice(1);
}

function shallowEqual(actual, expected) {
  for (var key in expected) {
    if (actual[key] !== expected[key]) {
      return false;
    }
  }

  return true;
}

function is(type, node, opts) {
  if (!node) return false;
  if (node.type !== type) return false;

  if (opts) {
    return shallowEqual(node, opts);
  }

  return true;
}

_each2['default'](_BUILDER_KEYS2['default'], function (keys, type) {
  exports[lcfirst(type)] = function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var node = { type: type };
    var i = 0;

    for (var key in keys) {
      node[key] = args[i] !== undefined ? args[i] : keys[key];
      i++;
    }

    return node;
  };
});

_each2['default'](_VISITOR_KEYS2['default'], function (keys, type) {
  exports['is' + type] = function (node, opts) {
    return is(type, node, opts);
  };
  exports['assert' + type] = function (node) {
    var opts = arguments[1] === undefined ? {} : arguments[1];

    if (!is(type, node, opts)) {
      throw new Error('Expected type ' + JSON.stringify(type) + ' with options ' + JSON.stringify(opts));
    }
  };
});